%global momorel 2
%define version 0.127

%if %{?_with_compat:1}%{!?_with_compat:0}
%define compat 1
%else
%define compat 0
%endif

Summary: A collection of utilities and DSOs to handle compiled objects.
Name: elfutils
Version: %{version}
%if !%{compat}
Release: %{momorel}m%{?dist}
%else
Release: 0.%{momorel}.1m%{?dist}
%endif
License: GPL
Group: Development/Tools
%NoSource 0 ftp://sources.redhat.com/pub/systemtap/elfutils/elfutils-%{version}.tar.gz 905411e1deda0aee17ae99dbdeaf7506
%NoSource 2 ftp://sources.redhat.com/pub/systemtap/elfutils/testfile16.symtab.bz2 07a924423a05b1bf6d0f9fe8b35dbe6b
%NoSource 3 ftp://sources.redhat.com/pub/systemtap/elfutils/testfile16.symtab.debug.bz2 bd40d1aaca8eaf1c7aea54bf4b29bda2
Patch0: elfutils-strip-copy-symtab.patch
Patch1: elfutils-portability.patch
Patch2: elfutils-robustify.patch
Patch10: elfutils-0.124-gcc42.patch
Obsoletes: libelf libelf-devel
Requires: elfutils-libelf = %{version}-%{release}
Requires: elfutils-libs = %{version}-%{release}

# ExcludeArch: xxx

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: bison >= 1.875
BuildRequires: flex >= 2.5.4a
BuildRequires: bzip2
%if !%{compat}
BuildRequires: gcc >= 3.4
# Need <byteswap.h> that gives unsigned bswap_16 etc.
BuildRequires: glibc-headers >= 2.3.4-11
%else
BuildRequires: gcc >= 3.2
%endif

%define _gnu %{nil}
%define _program_prefix eu-

%description
Elfutils is a collection of utilities, including ld (a linker),
nm (for listing symbols from object files), size (for listing the
section sizes of an object or archive file), strip (for discarding
symbols), readelf (to see the raw ELF file structures), and elflint
(to check for well-formed ELF files).


%package libs
Summary: Libraries to handle compiled objects.
Group: Development/Tools
Requires: elfutils-libelf = %{version}-%{release}
Conflicts: elfutils < %{version}-%{release}
Conflicts: elfutils > %{version}-%{release}
Conflicts: elfutils-devel < %{version}-%{release}
Conflicts: elfutils-devel > %{version}-%{release}

%description libs
The elfutils-libs package contains libraries which implement DWARF, ELF,
and machine-specific ELF handling.  These libraries are used by the programs
in the elfutils package.  The elfutils-devel package enables building
other programs using these libraries.

%package devel
Summary: Development libraries to handle compiled objects.
Group: Development/Tools
Requires: elfutils-libs = %{version}-%{release}
Requires: elfutils-libelf-devel = %{version}-%{release}

%description devel
The elfutils-devel package contains the libraries to create
applications for handling compiled objects.  libebl provides some
higher-level ELF access functionality.  libdw provides access to
the DWARF debugging information.  libasm provides a programmable
assembler interface.

%package libelf
Summary: Library to read and write ELF files.
Group: Development/Tools
Conflicts: elfutils < %{version}-%{release}
Conflicts: elfutils > %{version}-%{release}
Conflicts: elfutils-libs < %{version}-%{release}
Conflicts: elfutils-libs > %{version}-%{release}
Conflicts: elfutils-libelf-devel < %{version}-%{release}
Conflicts: elfutils-libelf-devel > %{version}-%{release}

%description libelf
The elfutils-libelf package provides a DSO which allows reading and
writing ELF files on a high level.  Third party programs depend on
this package to read internals of ELF files.  The programs of the
elfutils package use it also to generate new ELF files.

%package libelf-devel
Summary: Development support for libelf
Group: Development/Tools
Requires: elfutils-libelf = %{version}-%{release}
Conflicts: libelf-devel

%description libelf-devel
The elfutils-libelf-devel package contains the libraries to create
applications for handling compiled objects.  libelf allows you to
access the internals of the ELF object file format, so you can see the
different sections of an ELF file.

%prep
%setup -q

%patch0 -p1
cp %{SOURCE2} %{SOURCE3} tests

%if %{compat}
%patch1 -p1
sleep 1
find . \( -name Makefile.in -o -name aclocal.m4 \) -print | xargs touch
sleep 1
find . \( -name configure -o -name config.h.in \) -print | xargs touch
%endif

%patch2 -p1

%patch10 -p1 -b .gcc42

%build
# Remove -Wall from default flags.  The makefiles enable enough warnings
# themselves, and they use -Werror.  Appending -Wall defeats the cases where
# the makefiles disable some specific warnings for specific code.
RPM_OPT_FLAGS=${RPM_OPT_FLAGS/-Wall/}

%if %{compat}
# Some older glibc headers can run afoul of -Werror all by themselves.
# Disabling the fancy inlines avoids those problems.
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -D__NO_INLINE__"
%endif

if [ "`gcc -dumpversion | cut -c 0-3`.x" == "4.2.x" ]; then
    export RPM_OPT_FLAGS="$RPM_OPT_FLAGS -fgnu89-inline"
fi

# To remove -DPIC from CFLAGS for x86_64
%ifarch x86_64 
RPM_OPT_FLAGS=${RPM_OPT_FLAGS/-DPIC/}
%endif

%configure CFLAGS="$RPM_OPT_FLAGS -fexceptions " --program-prefix="eu-"
make %{?_smp_mflags}

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}

%makeinstall

chmod +x ${RPM_BUILD_ROOT}%{_prefix}/%{_lib}/lib*.so*
chmod +x ${RPM_BUILD_ROOT}%{_prefix}/%{_lib}/elfutils/lib*.so*

# XXX Nuke unpackaged files
{ cd ${RPM_BUILD_ROOT}
  rm -f .%{_bindir}/eu-ld
  rm -f .%{_bindir}/eu-objdump
  rm -f .%{_includedir}/elfutils/libasm.h
  rm -f .%{_libdir}/libasm-%{version}.so
  rm -f .%{_libdir}/libasm.so*
  rm -f .%{_libdir}/libasm.a
}

%check
# XXX elflint not happy on ia64
make check || :

%clean
rm -rf ${RPM_BUILD_ROOT}

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%post libelf -p /sbin/ldconfig

%postun libelf -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README TODO
%{_bindir}/eu-addr2line
%{_bindir}/eu-ar
%{_bindir}/eu-elfcmp
%{_bindir}/eu-elflint
%{_bindir}/eu-findtextrel
%{_bindir}/eu-nm
%{_bindir}/eu-ranlib
%{_bindir}/eu-readelf
%{_bindir}/eu-size
%{_bindir}/eu-strings
%{_bindir}/eu-strip
#%{_bindir}/eu-ld

%files libs
%defattr(-,root,root)
%{_libdir}/libdw-%{version}.so
#%{_libdir}/libasm.so.*
%{_libdir}/libdw.so.*
%dir %{_libdir}/elfutils
%{_libdir}/elfutils/lib*.so

%files devel
%defattr(-,root,root)
%{_includedir}/dwarf.h
%dir %{_includedir}/elfutils
%{_includedir}/elfutils/elf-knowledge.h
%{_includedir}/elfutils/libebl.h
%{_includedir}/elfutils/libdw.h
%{_includedir}/elfutils/libdwfl.h
#%{_libdir}/libasm.a
%{_libdir}/libebl.a
%{_libdir}/libdw.a
#%{_libdir}/libasm.so
%{_libdir}/libdw.so

%files libelf
%defattr(-,root,root)
%{_libdir}/libelf-%{version}.so
%{_libdir}/libelf.so.*

%files libelf-devel
%defattr(-,root,root)
%{_includedir}/libelf.h
%{_includedir}/gelf.h
%{_includedir}/nlist.h
%{_libdir}/libelf.a
%{_libdir}/libelf.so

%changelog
* Sat May 12 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.127-2m)
- revised CFLAGS for x86_64
 
* Wed May  2 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.127-1m)
- update 0.127

* Thu Mar 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.124-5m)
- -fgnu89-inline use gcc-4.2 only

* Thu Mar 15 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.124-4m)
- remove -fgnu89-inline

* Thu Mar 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (0.124-3m)
- fix gcc-4.2.
-- add -fgnu89-inline
-- elfutils-0.124-gcc42.patch

* Sun Oct 15 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.124-2m)
- replaced "ln" by "cp"

* Wed Oct 11 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.124-1m)
- version up (sync with elfutils-0_124-1_fc6)

* Fri May 19 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.119-1m)
- version up

* Tue Nov 30 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (0.97-1m)
- version up for gcc34
- cancel Patch0 (please revive if needed)

* Sun Jul 20 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.75-3m)
- fix unresolved symbols

* Sun Jul 20 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.75-2m)
- fix unresolved symbols

* Tue Apr 15 2003 Kenta MURATA <muraken2@nifty.com>
- (0.75-1m)
- first specfile from rawhide.
-* Mon Feb 24 2003 Elliot Lee <sopwith@redhat.com>
-- debuginfo rebuild
-
-* Thu Feb 20 2003 Jeff Johnson <jbj@redhat.com> 0.76-2
-- use the correct way of identifying the section via the sh_info link.
-
-* Sat Feb 15 2003 Jakub Jelinek <jakub@redhat.com> 0.75-2
-- update to 0.75 (eu-strip -g fix)
-
-* Tue Feb 11 2003 Jakub Jelinek <jakub@redhat.com> 0.74-2
-- update to 0.74 (fix for writing with some non-dirty sections)
-
-* Thu Feb  6 2003 Jeff Johnson <jbj@redhat.com> 0.73-3
-- another -0.73 update (with sparc fixes).
-- do "make check" in %%check, not %%install, section.
-
-* Mon Jan 27 2003 Jeff Johnson <jbj@redhat.com> 0.73-2
-- update to 0.73 (with s390 fixes).
-
-* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
-- rebuilt
-
-* Wed Jan 22 2003 Jakub Jelinek <jakub@redhat.com> 0.72-4
-- fix arguments to gelf_getsymshndx and elf_getshstrndx
-- fix other warnings
-- reenable checks on s390x
-
-* Sat Jan 11 2003 Karsten Hopp <karsten@redhat.de> 0.72-3
-- temporarily disable checks on s390x, until someone has
-  time to look at it
-
-* Thu Dec 12 2002 Jakub Jelinek <jakub@redhat.com> 0.72-2
-- update to 0.72
-
-* Wed Dec 11 2002 Jakub Jelinek <jakub@redhat.com> 0.71-2
-- update to 0.71
-
-* Wed Dec 11 2002 Jeff Johnson <jbj@redhat.com> 0.69-4
-- update to 0.69.
-- add "make check" and segfault avoidance patch.
-- elfutils-libelf needs to run ldconfig.
-
-* Tue Dec 10 2002 Jeff Johnson <jbj@redhat.com> 0.68-2
-- update to 0.68.
-
-* Fri Dec  6 2002 Jeff Johnson <jbj@redhat.com> 0.67-2
-- update to 0.67.
-
-* Tue Dec  3 2002 Jeff Johnson <jbj@redhat.com> 0.65-2
-- update to 0.65.
-
-* Mon Dec  2 2002 Jeff Johnson <jbj@redhat.com> 0.64-2
-- update to 0.64.
-
-* Sun Dec 1 2002 Ulrich Drepper <drepper@redhat.com> 0.64
-- split packages further into elfutils-libelf
-
-* Sat Nov 30 2002 Jeff Johnson <jbj@redhat.com> 0.63-2
-- update to 0.63.
-
-* Fri Nov 29 2002 Ulrich Drepper <drepper@redhat.com> 0.62
-- Adjust for dropping libtool
-
-* Sun Nov 24 2002 Jeff Johnson <jbj@redhat.com> 0.59-2
-- update to 0.59
-
-* Thu Nov 14 2002 Jeff Johnson <jbj@redhat.com> 0.56-2
-- update to 0.56
-
-* Thu Nov  7 2002 Jeff Johnson <jbj@redhat.com> 0.54-2
-- update to 0.54
-
-* Sun Oct 27 2002 Jeff Johnson <jbj@redhat.com> 0.53-2
-- update to 0.53
-- drop x86_64 hack, ICE fixed in gcc-3.2-11.
-
-* Sat Oct 26 2002 Jeff Johnson <jbj@redhat.com> 0.52-3
-- get beehive to punch a rhpkg generated package.
-
-* Wed Oct 23 2002 Jeff Johnson <jbj@redhat.com> 0.52-2
-- build in 8.0.1.
-- x86_64: avoid gcc-3.2 ICE on x86_64 for now.
-
-* Tue Oct 22 2002 Ulrich Drepper <drepper@redhat.com> 0.52
-- Add libelf-devel to conflicts for elfutils-devel
-
-* Mon Oct 21 2002 Ulrich Drepper <drepper@redhat.com> 0.50
-- Split into runtime and devel package
-
-* Fri Oct 18 2002 Ulrich Drepper <drepper@redhat.com> 0.49
-- integrate into official sources
-
-* Wed Oct 16 2002 Jeff Johnson <jbj@redhat.com> 0.46-1
-- Swaddle.
